/*
 * VITAL-5G vertical service LCM
 * VITAL-5G vertical service LCM
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.experiment.sbi.vslcm.api;


import com.google.gson.reflect.TypeToken;

import it.nextworks.experiment.sbi.vslcm.*;
import it.nextworks.experiment.sbi.vslcm.model.ExperimentExecutionSpec;
import it.nextworks.experiment.sbi.vslcm.model.ModifyVsRequest;
import it.nextworks.lcm.vs.elements.*;
import it.nextworks.lcm.vs.messages.*;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class VerticalServiceLcmApi {
    private ApiClient apiClient;

    public VerticalServiceLcmApi() {
        this(Configuration.getDefaultApiClient());
    }

    public VerticalServiceLcmApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }
    

    /**
     * Build call for deleteVsInstance
     * @param vsiId vsiId (required)
     * @param force  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteVsInstanceCall(String vsiId, Boolean force, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (force != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("force", force));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteVsInstanceValidateBeforeCall(String vsiId, Boolean force, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling deleteVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteVsInstanceCall(vsiId, force, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Delete a Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @param force  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteVsInstance(String vsiId, Boolean force) throws ApiException {
        deleteVsInstanceWithHttpInfo(vsiId, force);
    }

    /**
     * Delete a Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @param force  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteVsInstanceWithHttpInfo(String vsiId, Boolean force) throws ApiException {
        com.squareup.okhttp.Call call = deleteVsInstanceValidateBeforeCall(vsiId, force, null, null);
        return apiClient.execute(call);
    }

    /**
     * Delete a Vertical Service Instance (asynchronously)
     * 
     * @param vsiId vsiId (required)
     * @param force  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteVsInstanceAsync(String vsiId, Boolean force, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteVsInstanceValidateBeforeCall(vsiId, force, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getVSIs
     * @param tenant  (optional)
     * @param testbed  (optional)
     * @param usecase  (optional)
     * @param vsdid  (optional)
     * @param vsbid  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getVSIsCall(String tenant, String testbed, String usecase, String vsdid, String vsbid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (tenant != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("tenant", tenant));
        if (testbed != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("testbed", testbed));
        if (usecase != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("usecase", usecase));
        if (vsdid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("vsdid", vsdid));
        if (vsbid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("vsbid", vsbid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getVSIsValidateBeforeCall(String tenant, String testbed, String usecase, String vsdid, String vsbid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getVSIsCall(tenant, testbed, usecase, vsdid, vsbid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Vertical Service Instances
     * 
     * @param tenant  (optional)
     * @param testbed  (optional)
     * @param usecase  (optional)
     * @param vsdid  (optional)
     * @param vsbid  (optional)
     * @return List&lt;VerticalServiceInstanceInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<VerticalServiceInstanceInfo> getVSIs(String tenant, String testbed, String usecase, String vsdid, String vsbid) throws ApiException {
        ApiResponse<List<VerticalServiceInstanceInfo>> resp = getVSIsWithHttpInfo(tenant, testbed, usecase, vsdid, vsbid);
        return resp.getData();
    }

    /**
     * Get Vertical Service Instances
     * 
     * @param tenant  (optional)
     * @param testbed  (optional)
     * @param usecase  (optional)
     * @param vsdid  (optional)
     * @param vsbid  (optional)
     * @return ApiResponse&lt;List&lt;VerticalServiceInstanceInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<VerticalServiceInstanceInfo>> getVSIsWithHttpInfo(String tenant, String testbed, String usecase, String vsdid, String vsbid) throws ApiException {
        com.squareup.okhttp.Call call = getVSIsValidateBeforeCall(tenant, testbed, usecase, vsdid, vsbid, null, null);
        Type localVarReturnType = new TypeToken<List<VerticalServiceInstanceInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Vertical Service Instances (asynchronously)
     * 
     * @param tenant  (optional)
     * @param testbed  (optional)
     * @param usecase  (optional)
     * @param vsdid  (optional)
     * @param vsbid  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getVSIsAsync(String tenant, String testbed, String usecase, String vsdid, String vsbid, final ApiCallback<List<VerticalServiceInstanceInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getVSIsValidateBeforeCall(tenant, testbed, usecase, vsdid, vsbid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<VerticalServiceInstanceInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getVsInstance
     * @param vsiId vsiId (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getVsInstanceCall(String vsiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getVsInstanceValidateBeforeCall(String vsiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling getVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = getVsInstanceCall(vsiId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @return VerticalServiceInstance
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public VerticalServiceInstance getVsInstance(String vsiId) throws ApiException {
        ApiResponse<VerticalServiceInstance> resp = getVsInstanceWithHttpInfo(vsiId);
        return resp.getData();
    }

    /**
     * Get Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @return ApiResponse&lt;VerticalServiceInstance&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<VerticalServiceInstance> getVsInstanceWithHttpInfo(String vsiId) throws ApiException {
        com.squareup.okhttp.Call call = getVsInstanceValidateBeforeCall(vsiId, null, null);
        Type localVarReturnType = new TypeToken<VerticalServiceInstance>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Vertical Service Instance (asynchronously)
     * 
     * @param vsiId vsiId (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getVsInstanceAsync(String vsiId, final ApiCallback<VerticalServiceInstance> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getVsInstanceValidateBeforeCall(vsiId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<VerticalServiceInstance>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for instantiateVS
     * @param body request (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call instantiateVSCall(InstantiateVsRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call instantiateVSValidateBeforeCall(InstantiateVsRequest body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling instantiateVS(Async)");
        }
        
        com.squareup.okhttp.Call call = instantiateVSCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Instantiate Vertical Service
     * 
     * @param body request (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String instantiateVS(InstantiateVsRequest body) throws ApiException {
        ApiResponse<String> resp = instantiateVSWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Instantiate Vertical Service
     * 
     * @param body request (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> instantiateVSWithHttpInfo(InstantiateVsRequest body) throws ApiException {
        com.squareup.okhttp.Call call = instantiateVSValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Instantiate Vertical Service (asynchronously)
     * 
     * @param body request (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call instantiateVSAsync(InstantiateVsRequest body, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = instantiateVSValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for modifyVsInstance
     * @param body request (required)
     * @param vsiId vsiId (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call modifyVsInstanceCall(ModifyVsRequest body, String vsiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call modifyVsInstanceValidateBeforeCall(ModifyVsRequest body, String vsiId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling modifyVsInstance(Async)");
        }
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling modifyVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = modifyVsInstanceCall(body, vsiId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Modify Vertical Service Instance
     * 
     * @param body request (required)
     * @param vsiId vsiId (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void modifyVsInstance(ModifyVsRequest body, String vsiId) throws ApiException {
        modifyVsInstanceWithHttpInfo(body, vsiId);
    }

    /**
     * Modify Vertical Service Instance
     * 
     * @param body request (required)
     * @param vsiId vsiId (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> modifyVsInstanceWithHttpInfo(ModifyVsRequest body, String vsiId) throws ApiException {
        com.squareup.okhttp.Call call = modifyVsInstanceValidateBeforeCall(body, vsiId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Modify Vertical Service Instance (asynchronously)
     * 
     * @param body request (required)
     * @param vsiId vsiId (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call modifyVsInstanceAsync(ModifyVsRequest body, String vsiId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = modifyVsInstanceValidateBeforeCall(body, vsiId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for releaseVsInstance
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call releaseVsInstanceCall(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}/release"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (authenticated != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authenticated", authenticated));
        if (authorities0Authority != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authorities[0].authority", authorities0Authority));
        if (credentials != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("credentials", credentials));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("details", details));
        if (principal != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("principal", principal));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call releaseVsInstanceValidateBeforeCall(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling releaseVsInstance(Async)");
        }
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling releaseVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = releaseVsInstanceCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Release Vertical Service Instance
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object releaseVsInstance(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        ApiResponse<Object> resp = releaseVsInstanceWithHttpInfo(body, vsiId, authenticated, authorities0Authority, credentials, details, principal);
        return resp.getData();
    }

    /**
     * Release Vertical Service Instance
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> releaseVsInstanceWithHttpInfo(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        com.squareup.okhttp.Call call = releaseVsInstanceValidateBeforeCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Release Vertical Service Instance (asynchronously)
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call releaseVsInstanceAsync(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ApiCallback<Object> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = releaseVsInstanceValidateBeforeCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for terminateVsInstance
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call terminateVsInstanceCall(String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}/terminate"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (authenticated != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authenticated", authenticated));
        if (authorities0Authority != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authorities[0].authority", authorities0Authority));
        if (credentials != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("credentials", credentials));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("details", details));
        if (principal != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("principal", principal));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call terminateVsInstanceValidateBeforeCall(String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling terminateVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = terminateVsInstanceCall(vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Terminate Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void terminateVsInstance(String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        terminateVsInstanceWithHttpInfo(vsiId, authenticated, authorities0Authority, credentials, details, principal);
    }

    /**
     * Terminate Vertical Service Instance
     * 
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> terminateVsInstanceWithHttpInfo(String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        com.squareup.okhttp.Call call = terminateVsInstanceValidateBeforeCall(vsiId, authenticated, authorities0Authority, credentials, details, principal, null, null);
        return apiClient.execute(call);
    }

    /**
     * Terminate Vertical Service Instance (asynchronously)
     * 
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call terminateVsInstanceAsync(String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = terminateVsInstanceValidateBeforeCall(vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for useVsInstance
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call useVsInstanceCall(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/portal/vslcm/{vsiId}/use"
            .replaceAll("\\{" + "vsiId" + "\\}", apiClient.escapeString(vsiId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (authenticated != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authenticated", authenticated));
        if (authorities0Authority != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("authorities[0].authority", authorities0Authority));
        if (credentials != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("credentials", credentials));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("details", details));
        if (principal != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("principal", principal));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call useVsInstanceValidateBeforeCall(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling useVsInstance(Async)");
        }
        // verify the required parameter 'vsiId' is set
        if (vsiId == null) {
            throw new ApiException("Missing the required parameter 'vsiId' when calling useVsInstance(Async)");
        }
        
        com.squareup.okhttp.Call call = useVsInstanceCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Use Vertical Service Instance
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object useVsInstance(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        ApiResponse<Object> resp = useVsInstanceWithHttpInfo(body, vsiId, authenticated, authorities0Authority, credentials, details, principal);
        return resp.getData();
    }

    /**
     * Use Vertical Service Instance
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> useVsInstanceWithHttpInfo(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal) throws ApiException {
        com.squareup.okhttp.Call call = useVsInstanceValidateBeforeCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Use Vertical Service Instance (asynchronously)
     * 
     * @param body  (required)
     * @param vsiId vsiId (required)
     * @param authenticated  (optional)
     * @param authorities0Authority  (optional)
     * @param credentials  (optional)
     * @param details  (optional)
     * @param principal  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call useVsInstanceAsync(ExperimentExecutionSpec body, String vsiId, Boolean authenticated, String authorities0Authority, Object credentials, Object details, Object principal, final ApiCallback<Object> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = useVsInstanceValidateBeforeCall(body, vsiId, authenticated, authorities0Authority, credentials, details, principal, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
